#include <vector>
#include <cstdlib>
#include <sstream>

template <typename T>
inline void shuffle
  ( std :: vector <unsigned> const & order
  , std :: vector <T> const & from
  , std :: vector <T> & to
  )
{ to . resize (order . size ());
  for (unsigned i = 0;  i < to . size ();  i ++)
    to [i] = from [order [i]];
}

template <typename T>
inline void shuffle
  ( std :: vector <unsigned> const & order
  , std :: vector <T> & data
  )
{ vector <T> tmp = data;
  shuffle (order, tmp, data);
}

inline void acceptToken (string & text, string token, unsigned & pos)
{
  while (pos < text . size () && text [pos] == ' ')  pos ++;
  string cmp = text . substr (pos, token . size ());
  if (cmp != token)
  { cerr << "expected " << token << ", got " << cmp << endl;
    exit (1);
  }
  pos += token . size ();
}

template <typename T>
inline void readFromString (string & text, unsigned & pos, T & val)
{
  unsigned len = 0;
  while
  (    pos < text . size ()
    && (  (text [pos + len] >= '0' && text [pos + len] <= '9')
       || text [pos + len] == '.'
       )
  )
    len ++;
  string tok = text . substr (pos, len);
  istringstream s (tok);
  s >> val;
  pos += len;
}
