#include <vector>
#include <cstdlib>
#include <iostream>

inline void enum2perm (unsigned e, std :: vector <unsigned> & p)
{
  p [0] = 0;
  for (unsigned i = 1;  i < p . size ();  i ++)
  { p [i] = i;
    std :: swap (p [i], p [i - (e % (i + 1))]);
    e /= i + 1;
  }
}


inline void firstPermutation (std :: vector <unsigned> & p, unsigned n = 0)
{
  if (n == 0)  n = p . size ();
  for (unsigned i = 0;  i < n;  i ++)  p [i] = i;
}


inline bool nextPermutation (std :: vector <unsigned> & p, unsigned n = 0)
{
  if (p . size () < 2)  return false;
  if (n == 0)  n = p . size ();
  int a = n - 2;
  while (a >= 0 && p [a] > p [a + 1])  a --;
  if (a == -1)  return false;
  int b = n - 1;
  while (p [b] < p [a])  b --;
  std :: swap (p [a], p [b]);
  b = n - 1;  a ++;
  while (a < b)  {std :: swap (p [a], p [b]);  a ++;  b --;}
  return true;
}

inline void randomPermutation (std :: vector <unsigned> & p, unsigned n = 0)
{
  if (n == 0)  n = p . size ();
  for (unsigned i = 0;  i < n;  i ++)  p [i] = i;
  for (unsigned i = 0;  i < n - 1;  i ++)
    std :: swap (p [i], p [i + rand () % (n - i)]);
}

inline std :: ostream & operator<< (std :: ostream & s, std :: vector <unsigned> const & p)
{
  s << '(';
  for (unsigned i = 0;  i < p . size ();  i ++)
  { if (i > 0)  s << ", ";
    s << p [i];
  }
  s << ')';
  return s;
}


#ifdef test_permutation
#include <fstream>

using namespace std;

int main (int argc, char * argv [])
{
  unsigned n = atoi (argv [1]);
  vector <unsigned> p (n);
/*
  unsigned np = 1;  for (unsigned i = 2;  i <= n;  i ++)  np *= i;
  for (unsigned e = 0;  e < np;  e ++)
  { enum2perm (e, p);
    for (unsigned i = 0;  i < n;  i ++)  cout << p [i] << ' ';
    cout << endl;
  }
*/
  for (unsigned i = 0;  i < n;  i ++)  p [i] = i;
  do
  { for (unsigned i = 0;  i < n;  i ++)  cout << p [i] << ' ';
    cout << endl;
  }
  while (nextPermutation (p));
/*
  { unsigned seed;
    ifstream rs ("/dev/urandom");
    rs . read (reinterpret_cast <char *> (& seed), sizeof (seed));
    srand (seed);
  }
  randomPermutation (p);
  cout << p << endl;
*/
}

#endif

